-- Rotary Encoder Controller
-- E̎right_pulseoB̎left_pulseoB
-- Rotray switch̉{^XCb`pulseoB

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity rot_enc_cont is
	port(
		clk : in std_logic;
		reset : in std_logic;
		rot_a : in std_logic;
		rot_b : in std_logic;
		rot_center : in std_logic;
		right_pulse : out std_logic;
		left_pulse : out std_logic;
		center_pulse : out std_logic
	);
end rot_enc_cont;

architecture RTL of rot_enc_cont is
component SWDiv
	generic(
		clk_frequency : integer := 50000 -- KHz
	);
	port(
		clk, reset : in std_logic;
		sw_ena : out std_logic	
	);
end component;
component ROTSW_SM
	PORT (CLK,RESET,rot_center_node,Switch_A,Switch_B: IN std_logic;
		center_pulse,left_pulse,right_pulse : OUT std_logic);
end component;

signal sw_ena : std_logic;
signal rot_a_node, rot_b_node, rot_center_node : std_logic;
begin
	SWDiv_inst : SWDiv generic map(
		clk_frequency => 50000
	) port map(
		clk => clk,
		reset => reset,
		sw_ena => sw_ena
	);
	
	ROTSW_SM_inst : ROTSW_SM port map(
		clk => clk,
		reset => reset,
		Switch_A => rot_a_node,
		Switch_B => rot_b_node,
		rot_center_node => rot_center_node,
		right_pulse => right_pulse,
		left_pulse => left_pulse,
		center_pulse => center_pulse
	);
	
	process(reset, clk) begin
		if reset='1' then
			rot_a_node <= '0';
		elsif clk'event and clk='1' then
			if sw_ena='1' then -- 1msƂsw_ena1ɂȂ
				rot_a_node <= rot_a;
			end if;
		end if;
	end process;
	
	process(reset, clk) begin
		if reset='1' then
			rot_b_node <= '0';
		elsif clk'event and clk='1' then
			if sw_ena='1' then -- 1msƂsw_ena1ɂȂ
				rot_b_node <= rot_b;
			end if;
		end if;
	end process;
	
	process(reset, clk) begin
		if reset='1' then
			rot_center_node <= '0';
		elsif clk'event and clk='1' then
			if sw_ena='1' then -- 1msƂsw_ena1ɂȂ
				rot_center_node <= rot_center;
			end if;
		end if;
	end process;
end RTL;
